;                       asmselect.asm

;  a loader for Qeditor
; it searches the masm32 folder and sub folders for
; ASM, INC and RC files. Sorts by using the date/time modified field 
; and the top 100 are displayed in reverse order ie. latest first.
; Qeditor is located by searching the folder in which
; this program resides.

; #########################################################################

      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;     include files
;     ~~~~~~~~~~~~~
      include \MASM32\INCLUDE\windows.inc
      include \MASM32\INCLUDE\gdi32.inc
      include \MASM32\INCLUDE\user32.inc
      include \MASM32\INCLUDE\kernel32.inc
      include \MASM32\INCLUDE\Comctl32.inc
      include \MASM32\INCLUDE\comdlg32.inc
      include \MASM32\INCLUDE\shell32.inc
      include \masm32\include\ole32.inc

;     libraries
;     ~~~~~~~~~

      includelib \MASM32\LIB\gdi32.lib
      includelib \MASM32\LIB\user32.lib
      includelib \MASM32\LIB\kernel32.lib
      includelib \MASM32\LIB\Comctl32.lib
      includelib \MASM32\LIB\comdlg32.lib
      includelib \MASM32\LIB\shell32.lib
      includelib \masm32\lib\ole32.lib

; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
WinMain           PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc           PROTO :DWORD,:DWORD,:DWORD,:DWORD
TopXY             PROTO :DWORD,:DWORD
FillBuffer        PROTO :DWORD,:DWORD,:BYTE
Paint_Proc        PROTO :DWORD,:DWORD
ListBox           PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
SearchForFile     PROTO :DWORD, :DWORD, :DWORD
SearchForAsmFile  PROTO :DWORD
FillBuffer        PROTO :DWORD,:DWORD,:BYTE
TransferProc      PROTO :DWORD
FindFiles         PROTO :DWORD
PushButton        PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
BrowseForFolder   PROTO :DWORD,:DWORD,:DWORD,:DWORD
cbBrowse          PROTO :DWORD,:DWORD,:DWORD,:DWORD
SearchNewFolder   PROTO :DWORD
Ed1Proc           PROTO :DWORD,:DWORD,:DWORD,:DWORD
ListBoxProc       PROTO :DWORD,:DWORD,:DWORD,:DWORD
ShowHelpWindow    PROTO :DWORD
ucase             PROTO :DWORD

        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

szText      MACRO Name, Text:VARARG
LOCAL lbl
            jmp lbl
Name  db    Text,0
lbl:
            ENDM

m2m         MACRO M1, M2
            push M2
            pop  M1
            ENDM

return      MACRO arg
            mov eax, arg
            ret
            ENDM

RGB         MACRO red,green,blue
            xor eax,eax
            mov ah,blue
            shl eax,8
            mov ah,green
            mov al,red
endm

@ClearFN    MACRO
            lea edi,WFD.cFileName    ; put address of file name in EDI 
            mov ecx,260              ; we're gonna do this 260 times
            xor al,al                ; clear AL
            rep stosb                ; clear all chars in WFD.cFileName
            ENDM

@GetToChar  MACRO
            scasb                    ; check for zero
            jnz $-1                  ; loop until zero is found

            dec edi                  ; go back one char
            ENDM
.data?
CommandLine dd    ?
hWnd        dd    ?
hInstance   dd    ?
hMenu       dd    ?
hIcon       dd    ?
hFont       dd    ?
hList       dd    ?
hListV      dd    ?
hListH      dd    ?
hButn       dd    ?
HoldT       dd    ?
TotalFiles  dd    ?
ThreadID    dd    ?
hListView   dd    ?
lpfnEd1Proc dd    ?
hStatic     dd    ?
hStaticH    dd    ?
hBrush      dd    ?

fDate       db    12 dup  (?)
fTime       db    10 dup  (?)
Work16      db    36 dup  (?)
EditorPath  db    260 dup (?)
ViewerPath  db    250 dup (?)
TrackPath   db    260 dup (?)
szFileName  db    260 dup (?)
ModulePath  db    260 dup (?)

ListBoxReturnAddr dd    ?
ThreadHandle      dd    ?
hwndProgress      dd    ?
ClearListBox      dd    ?

SYSTEMTIME STRUCT
  wYear             WORD      ?
  wMonth            WORD      ?
  wDayOfWeek        WORD      ?
  wDay              WORD      ?
  wHour             WORD      ?
  wMinute           WORD      ?
  wSecond           WORD      ?
  wMilliseconds     WORD      ?
SYSTEMTIME ENDS

time  SYSTEMTIME        <?>
ofn   OPENFILENAME      <?>

.data
AsmExt      db    '.asm',0
RcExt       db    '.rc',0
IncExt      db    '.inc',0
EditorName  db    'Qeditor.exe',0  
ViewerName  db    'TheGun.exe',0
Comma       db    ',',0
FmtString02 db    '%02u',0                ;convert to decimal 2 char zero fill
FmtString2  db    '%2u',0                 ;convert to decimal 2 char zero suppress
FmtString3  db    '%03u',0                ;convert to decimal 3 char zero fill
FmtString4  db    '%04u',0                ;convert to decimal 4 char zero fill
szOpenTitle db    'Open Source File',0
szFilter    db    "Assembly Files *.ASM,*.RC,*.INC",0h,"*.asm;*.inc;*.rc",0h
            db    "All Files      *.*",0h,"*.*",0h,0h
Heading1    db    "Filename",0
Heading2    db    "  Date",0
Heading3    db    '  Time',0
Heading4    db    'Path',0
ColSize1    dd    150
ColSize2    dd    95
ColSize3    dd    85
ColSize4    dd    400
OpenFileCmd db    'open',0
NoEditorMsg db    'Unable to locate Qeditor.exe',0dh,0ah
            db    'This loader program should be placed ',0dh,0ah
            db    'in the same folder as Qeditor.',0dh,0ah
            db    '(Usually drive letter :\Masm32.)',0
NoFilesMsg  db    'No source files were found.',0dh,0ah
            db    'Press OK to select another folder, or',0dh,0ah
            db    'Cancel to use existing search results.',0
NoHelpMsg   db    'Unable to create help screen.',0
SearchMsg   db    'Select Folder with Source Files',0
HelpMsg     db    '       Left Double Click on an item to launch Qeditor.',0
            db    '       Right Click to activate pop-up menu.',0
            db    '       Press New Project Button to go straight to Qeditor.',0
            db    '       File/NewProject will go straight to Qeditor.',0
            db    '       File/NewFolder will allow th user to select a folder'
            db    ' to search and display.',0
            db    '       File/Open will alow you to choose a file to edit.',0
            db    '       File/Exit will cancel the program.',0
            db    '       Esc key will cancel the program.',0
            dd    0

NoListBoxMsg      db    'Unable to create the main listbox',0dh,0ah
                  db    'the program cannot run.',0
ItemsToShow       dd    100
szDisplayName     db    "Choose Assembler File to Edit",0
ListViewClassName db    "SysListView32",0
ProgressClass     db    "msctls_progress32",0

IDC_PROGRESS      equ   1
IDC_STATIC        equ   599
IDC_STATICH       equ   598
WM_THREADMSG      equ   WM_USER+106h
;
; Options menu
;
IDM_TITLE        equ 4001
;
; File menu
;
IDM_FILE          equ   5008
IDM_NEW           equ   5001
IDM_OPEN          equ   5002
IDM_FOLDER        equ   5003
IDM_EXIT          equ   5007
;
; Help menu
;
IDM_HELPM         equ   5403
IDM_ABOUT         equ   5401
IDM_HELP          equ   5402
;
; Menu template
;
MFR_END           equ   80h
MFR_POPUP         equ   01h

align   4         ; must align on DWORD boundary
MyMenuTemplate    dw 1    ; menu template version

                  dw 4    ; offset from end of this word to menu item list
                  dd 0    ; menu bar help ID

                  dd MFT_STRING,MFS_ENABLED,IDM_FILE
                  dw MFR_POPUP                    ; first column
                  dw '&','F','i','l','e',0,0      ; pad to align 4
                  dd 0                            ; popup help ID

                  dd MFT_STRING,MFS_ENABLED,IDM_NEW
                  dw 0
                  dw '&','N','e','w',' ','P','r','o'
                  dw 'j','e','c','t',0

                  dd MFT_STRING,MFS_ENABLED,IDM_FOLDER
                  dw 0
                  dw 'N','e','w',' ','&','F','o','l'
                  dw 'd','e','r',' ',0

                  dd MFT_STRING,MFS_ENABLED,IDM_OPEN
                  dw 0
                  dw '&','O','p','e','n','.','.','.',0
                  dd MFT_SEPARATOR,0,0
                  dw 0,0                              ;pad to align 4

                  dd MFT_STRING,MFS_ENABLED,IDM_EXIT
                  dw MFR_END                          ; bottom of column
                  dw 'E','&','x','i','t',0,0          ; pad to align 4
;Help Menu
                  dd MFT_STRING,MFS_ENABLED,IDM_HELPM
                  dw MFR_POPUP or MFR_END             ; second column, last one
                  dw '&','H','e','l','p',0,0          ; pad to align 4
                  dd 0                                ; popup help ID

                  dd MFT_STRING,MFS_ENABLED,IDM_HELP
                  dw 0
                  dw '&','H','e','l','p','.','.','.',0

                  dd MFT_STRING,MFS_ENABLED,IDM_ABOUT
                  dw MFR_END                          ; bottom of column
                  dw '&','A','b','o','u','t','.','.','.',0,0
;---------------------
;  popup menu stuff
;---------------------
.const
IDM_VIEW    equ   302
IDM_COPY    equ   300
IDM_SELECT  equ   301
IDM_SHOWALL equ   303

.data?
hMenuP      dd    ?

.data
CRLF        db    0dh,0ah,0
ViewMsg     db    '   View Selected File.',0
FileMsg     db    '   Choose the file to edit.',0
FolderMsg   db    '   Choose a different folder to search.',0
CopyMsg     db    '   Copy selected items to the ClipBoard.   ',0
SelectMsg   db    '   Select All Items.',0
ChangeMsg   db    '   Show All Source Files.   ',0

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke InitCommonControls

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

LOCAL wc    :WNDCLASSEX
LOCAL msg   :MSG
LOCAL Wwd   :DWORD
LOCAL Wht   :DWORD
LOCAL Wtx   :DWORD
LOCAL Wty   :DWORD

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

;      invoke LoadIcon,hInst,500    ; icon ID
;      mov hIcon, eax

      szText szClassName,"FindSource_Class"

      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                             or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      mov wc.hbrBackground,  COLOR_BTNFACE+1
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
        invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      ;================================
      ; Centre window at following size
      ;================================

      mov Wwd, 500
      mov Wht, 350

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty, eax

      invoke CreateWindowEx,WS_EX_LEFT,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPEDWINDOW,
                            Wtx,Wty,Wwd,Wht,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke LoadMenuIndirect,offset MyMenuTemplate
      mov    hMenu,eax
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

LOCAL hDC   :DWORD
LOCAL Ps    :PAINTSTRUCT
LOCAL Rct   :RECT
LOCAL lvi   :LV_ITEM

LOCAL Items2Copy  :DWORD
LOCAL ItemIndex   :DWORD
LOCAL TotalSize   :DWORD
LOCAL SubItem     :DWORD

LOCAL szBuff   [260]    :BYTE
LOCAL lpBuffer [260]    :BYTE    

    .if uMsg == WM_CREATE
;-----------------------------------------------------
; get drive letter and path from the module filename
;-----------------------------------------------------
      invoke    GetModuleFileName,hInstance, addr ModulePath,sizeof ModulePath
      .if eax != 0
        mov     ecx,eax
        mov     edx,eax
        mov     edi,offset ModulePath
        add     edi,ecx
        mov     al,'\'
        std
        repne   scasb
        cld
        inc     edi
        mov     dword ptr [edi],0
      .endif
;----------------------
; find Qeditor path
;----------------------
      invoke    SearchForFile,addr ModulePath,addr EditorName, addr EditorPath
      .if eax == -1
        call    FindQ
        .if eax==-1
          invoke  MessageBoxEx,hWin,addr NoEditorMsg,addr szDisplayName,\
                                    MB_ICONQUESTION or MB_OK, NULL
          invoke PostQuitMessage,NULL
          return 0
        .endif
      .endif
;-------------------------
;  search for file viewer
;-------------------------
      invoke    SearchForFile,addr ModulePath,addr ViewerName,addr ViewerPath
;------------------------------------
;  create the 'new project' button
;------------------------------------
      szText btnName,"Start  A  New  Project"
      invoke PushButton,ADDR btnName,hWin,50,320,200,25,500
      mov    hButn,eax
;--------------------------------------------------
;  use a listbox to store and sort the file paths.
;  it's hidden from the user
;--------------------------------------------------
      .if hList==0
        invoke ListBox,0,0,0,0,hWin,600
        .if eax == 0
          invoke  MessageBoxEx,hWin,addr NoListBoxMsg,addr szDisplayName,\
                               MB_ICONQUESTION or MB_OK, NULL
          invoke PostQuitMessage,NULL
        .endif
        mov    hList,eax
        invoke ShowWindow,hList,SW_HIDE
      .endif
;---------------------------------------
;  run file search routine in a thread
;---------------------------------------
      invoke CreateThread,NULL,NULL,addr FindFiles,hWin,0,ADDR ThreadID 
      mov    ThreadHandle,eax        
;----------------------
;  menu commands
;----------------------
    .elseif uMsg == WM_COMMAND
      mov   eax,wParam                    ;process menu commands
      and   eax,0ffffh
      .if eax==IDM_EXIT                   ;exit option
        .if ThreadHandle>0
          invoke CloseHandle,ThreadHandle
          mov   ThreadHandle,0
        .endif
        invoke SendMessage,hWnd,WM_DESTROY,0,0
        return 0 
 
      .elseif eax==IDM_NEW                ;file new option
        jmp    NewProjectTag

      .elseif eax==IDM_FOLDER             ;new folder
        invoke SearchNewFolder,hWin
        return 0

      .elseif eax==IDM_OPEN               ;file open option
        invoke FillBuffer,addr ofn,sizeof ofn,0
        mov    ofn.lStructSize,sizeof ofn
        m2m    ofn.hwndOwner,hWnd
        m2m    ofn.hInstance,hInstance
        mov    ofn.lpstrFilter,offset szFilter
        mov    ofn.lpstrFile,offset szFileName
        mov    byte ptr [szFileName],0
        mov    ofn.nMaxFile,sizeof szFileName
        mov    ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST
        invoke GetOpenFileName,addr ofn
        .if eax!=0
          invoke lstrcpy,addr szBuff,addr szFileName  ; put filename in buffer
          jmp     @F                                  ; run Qeditor
        .else
          invoke SetFocus,hListV                      ; highlight the selected items
        .endif
        return 0

      .elseif eax == IDM_ABOUT
        szText AboutMsg,"ASM Selector Version 5  Tortuously Written in \
                        Win32 Assembler Language"
        invoke ShellAbout,hWin,ADDR szDisplayName,ADDR AboutMsg,hIcon
        return 0

      .elseif eax == IDM_HELP
        invoke ShowHelpWindow,hWin
        return 0

      .elseif eax == 500                              ; new project button
        jmp    NewProjectTag

      .elseif eax==IDM_VIEW                           ; popup menu item
        invoke  FillBuffer,addr lvi,sizeof lvi,0
        invoke  SendMessage, hListV, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        .if eax != -1
          mov     lvi.iItem, eax          ; row
          mov     lvi.iSubItem, 3         ; column
          mov     lvi.imask, LVIF_TEXT    ; what data to retrieve
          lea     eax, szBuff             ; where to put it
          mov     lvi.pszText, eax
          mov     lvi.cchTextMax, 256     ; maximum size to retrieve

          invoke  SendMessage, hListV, LVM_GETITEM, 0, addr lvi
          invoke  ShellExecute,hWin,addr OpenFileCmd,addr ViewerPath,
                               addr szBuff,0, SW_SHOWNORMAL
        .endif

      .elseif eax==IDM_COPY                           ; popup menu item
        .if lParam==0
          call  Copy2ClipBoard
        .endif

      .elseif eax==IDM_SELECT                         ; popup menu item
        .if lParam==0
          invoke SetFocus,hListV                      ; make highlighting visible
          invoke FillBuffer,addr lvi,sizeof lvi,0
          invoke SendMessage, hListV, LVM_SETITEMSTATE, -1, addr lvi
          mov    lvi.state, LVIS_SELECTED	
          mov    lvi.stateMask, LVIS_SELECTED
          invoke SendMessage, hListV, LVM_SETITEMSTATE, -1, addr lvi
        .endif
;-------------------------------------------
; show all source files,
; copy entire listbox to listview
;-------------------------------------------
      .elseif eax==IDM_SHOWALL                        ; popup menu item
        .if lParam==0
          mov    ItemsToShow,-1                       ; show all factor
          invoke TransferProc,hWin
          invoke EnableMenuItem,hMenuP,IDM_SHOWALL,MF_DISABLED or MF_GRAYED
        .endif
      .endif
;----------------------------------
;  end of file search thread
;----------------------------------
    .elseif uMsg==WM_THREADMSG                 ;end of file search
      mov   ThreadHandle,0
      .if TotalFiles !=0
        invoke TransferProc,hWin
      .else
        invoke MessageBox,hWin,addr NoFilesMsg,addr szDisplayName,MB_OKCANCEL or \
                          MB_ICONQUESTION or MB_DEFBUTTON1
        .if eax == IDOK
          invoke SearchNewFolder,hWin
        .endif
      .endif
      return 0
;-----------------------------------------
;  escape key will cancel the program
;-----------------------------------------
    .elseif uMsg == WM_CHAR
      .if wParam==VK_ESCAPE
        invoke SendMessage,hWnd,WM_DESTROY,0,0
      .endif

    .elseif uMsg == WM_PAINT
      invoke SetFocus,hListV              ; highlight the selected items

    .elseif uMsg==WM_CTLCOLORLISTBOX
      mov   eax,lParam
      .if eax==hListH
        RGB    197,255,215   ;     RGB 255,206,206
        push   eax
        invoke SetBkColor,wParam,eax
        pop    eax
        invoke CreateSolidBrush,eax                 
        mov    hBrush,eax
        ret
      .endif
;----------------------------------------------------------------
; change the sizes of our windows to reflect the users choice
;----------------------------------------------------------------
    .elseif uMsg == WM_SIZE
      invoke SetFocus,hListV             ; highlight the selected items
      invoke GetWindowRect,hWnd,addr Rct
      mov    eax,Rct.right
      sub    eax,Rct.left
      mov    edx,Rct.bottom
      sub    edx,Rct.top
      sub    edx,90
      sub    eax,25
      push   eax
      push   edx
      invoke MoveWindow,hListV,10,0,eax,edx,TRUE
      pop    edx
      pop    eax
      push   eax
      push   edx
      invoke MoveWindow,hListH,10,0,eax,edx,TRUE
      pop    edx
      pop    eax
      add    edx,10
      invoke MoveWindow,hButn,10,edx,eax,25,TRUE

      return 0
;------------------------------------
;  double click on a listview item
;------------------------------------
    .elseif uMsg == WM_NOTIFY
      mov     ecx, lParam
      mov     eax, [ecx.NMHDR].hwndFrom
      .if eax == hListV
        .if [ecx.NMHDR.code] == NM_DBLCLK
          invoke  FillBuffer,addr lvi,sizeof lvi,0
          invoke  SendMessage, hListV, LVM_GETNEXTITEM, -1, LVNI_SELECTED
          .if eax != -1
            mov     lvi.iItem, eax
            mov     lvi.iSubItem, 3
            mov     lvi.imask, LVIF_TEXT
            lea     eax, szBuff
            mov     lvi.pszText, eax
            mov     lvi.cchTextMax, 256
            invoke  SendMessage, hListV, LVM_GETITEM, 0, addr lvi
            jmp     short @F
NewProjectTag:
            lea     edi,szBuff                        ; make buffer appear empty
            mov     byte ptr [edi],0                  ; with a zero at the start
@@:
            invoke  ShellExecute,hWin,addr OpenFileCmd,addr EditorPath,
                                 addr szBuff,0, SW_SHOWMAXIMIZED
            invoke  SendMessage,hWnd,WM_DESTROY,0,0
            return  0
          .endif
        .endif
      .endif

    .elseif uMsg == WM_DESTROY
      .if ThreadHandle>0
        invoke CloseHandle,ThreadHandle
        mov   ThreadHandle,0
      .endif

      .if hBrush>0
        invoke DeleteObject,hBrush
      .endif

      invoke PostQuitMessage,NULL
      return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; #########################################################################

ListBox proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD
;-----------------------------------------------
;  create a listbox which has a cancel button
;  and will sort the contents
;-----------------------------------------------
    szText lstBox,"LISTBOX"

    invoke CreateWindowEx,WS_EX_STATICEDGE,ADDR lstBox,0,
                          WS_VISIBLE or WS_CAPTION or WS_SYSMENU or \
                          WS_BORDER or WS_CHILD or WS_HSCROLL or \
                          LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or \
                          LBS_SORT or LBS_NOSEL,
                          a,b,wd,ht,hParent,ID,hInstance,NULL
    ret

ListBox endp

; ###########################################################
ListBoxProc proc  hCtl   :DWORD,
                  uMsg   :DWORD,
                  wParam :DWORD,
                  lParam :DWORD
;-----------------------------------------
;  trap messages sent to the listbox
;  notably, close window and mouse action
;-----------------------------------------
      .if uMsg == WM_CLOSE || \
          uMsg == WM_LBUTTONUP
        invoke ShowWindow,hListH,SW_HIDE
        invoke ShowWindow,hListV,SW_SHOW
        invoke EnableWindow,hButn,TRUE
        invoke EnableMenuItem,hMenu,IDM_FILE,MF_ENABLED
        invoke EnableMenuItem,hMenu,IDM_HELPM,MF_ENABLED
        invoke DrawMenuBar,hWnd
        return 0
      .endif

      invoke CallWindowProc,ListBoxReturnAddr,hCtl,uMsg,wParam,lParam

      ret

ListBoxProc endp

; ############################################################
;-----------------------------------
; search for 'FileToFind'
; in the 'StartPath' directory
; returns -1 if unsuccessful
; copies the path into 'Destination'
;-----------------------------------
SearchForFile PROC StartPath:DWORD,FileToFind:DWORD,Destination:DWORD

LOCAL WFD         :WIN32_FIND_DATA     ; used for file/folder search
LOCAL fPath[260]  :BYTE       ; used to store StartPath locally
LOCAL fPath2[260] :BYTE       ; we add sub-folders names onto this to form full paths
LOCAL hFind       :DWORD      ; find handle

      mov    esi,StartPath                ; copy StartPath to our buffer
      mov    byte ptr [esi+256],0
      invoke lstrcpy,addr fPath,esi
      invoke lstrlen,addr fPath
      lea    edi,fPath      
      mov    dword ptr [edi+eax],2a5ch    ;add '\*',0,0   to end of path

      @ClearFN                            ; clears the cFileName field in Win32_Find_Data
                        
      invoke FindFirstFile,addr fPath,addr WFD        ; find first file
      .if eax == -1               
        ret
      .endif

      mov    hFind,eax                    ; save FindHandle
      mov    ebx,eax                      ; put handle in EBX
                
    .while ebx > 0                        ; while a file is found..
      lea    esi,WFD.cFileName
      lodsw                               ; get first two chars

      .if AX!=02E2Eh && AX!=0002Eh        ; '..' and '.'          
        lea  edi,WFD
        mov  eax,[edi] ; file attributes

        .if ax & FILE_ATTRIBUTE_DIRECTORY       ; skip if a directory
          sub esi,2                             ; undo the lodsw
        .else
          sub esi,2                             ; undo the lodsw
          invoke lstrcmpi,FileToFind,esi        ; case insensitive compare
          or eax,eax                            ; are they equal?
          jz found_file                         ; if eax=0 they are equal
        .endif
      .endif
          
      @ClearFN        ; Clear the cFileName field again
                                
      invoke FindNextFile,hFind,addr WFD
      mov    ebx,eax
    .endw
      mov    eax,-1                             ; return fail
      jmp short @F                              ; file not found
found_file:
      invoke lstrcpy,addr fPath2,addr fPath
      lea   edi,fPath2
      mov al,'*'
      scasb
      jnz $-1
      dec edi
      mov byte ptr [edi],0
      invoke lstrcat,addr fPath2,addr WFD.cFileName
      invoke lstrcpy,Destination,addr fPath2        
      xor   eax,eax                             ;return success
@@:
      push   eax
      invoke FindClose,hFind                    ; close it up
      pop    eax

      ret

SearchForFile ENDP

; ######################################################################

FindFiles   proc  hWin

;-------------------------
;  create a progress bar
;-------------------------
      invoke CreateWindowEx,NULL,ADDR ProgressClass,NULL,\
                            WS_CHILD+WS_VISIBLE,100,\
                            180,300,20,hWnd,IDC_PROGRESS,\
                            hInstance,NULL
      mov    hwndProgress,eax

      mov    eax,1000              ;whole bar = 1000
      shl    eax,16                ;move to upper bits
      invoke SendMessage,hwndProgress,PBM_SETRANGE,0,eax
      invoke SendMessage,hwndProgress,PBM_SETSTEP,10,0  ; step size = 10
      invoke SendMessage,hwndProgress,PBM_SETBARCOLOR,0,Blue + 50
;-----------------------------------------------------
;  create a static window to show retrieved filnames
;-----------------------------------------------------
      szText StaticClass,"Static"
      invoke CreateWindowEx,NULL,ADDR StaticClass,NULL,\
                            WS_CHILD+WS_VISIBLE,100,\
                            210,300,20,hWnd,IDC_STATIC,\
                            hInstance,NULL
      mov    hStatic,eax
;---------------------------------
; set a flag to clear the listbox
;---------------------------------
      mov    ClearListBox,0
;------------------------------------
;  hide the listview while searching
;------------------------------------
      invoke ShowWindow,hListV,SW_HIDE
;------------------------
; get source files
;------------------------
      invoke SearchForAsmFile,addr ModulePath         ; main search routine
      invoke PostMessage,hWnd,WM_THREADMSG,NULL,NULL  ; tell user that it's done 

      invoke DestroyWindow,hwndProgress               ; no longer needed
      invoke DestroyWindow,hStatic                    ; no longer needed
;----------------------------------
; search over, show listview
;----------------------------------
      invoke ShowWindow,hListV,SW_SHOW
      ret

FindFiles    endp
;#############################################################

SearchForAsmFile PROC StartPath:DWORD

LOCAL WFD         :WIN32_FIND_DATA     ; used for file/folder search
LOCAL fPath[260]  :BYTE       ; used to store StartPath locally
LOCAL fPath2[260] :BYTE       ; we add sub-folders names onto this to form full paths
LOCAL hFind       :DWORD      ; find handle
LOCAL Lft         :FILETIME

      mov    esi,StartPath                ; copy StartPath to our buffer
      mov    byte ptr [esi+256],0
      invoke lstrcpy,addr fPath,esi
      invoke lstrlen,addr fPath
      lea    edi,fPath      
      .if byte ptr [edi+eax-1]=='\'       ; check for root directory
        dec eax                           ; adjust value
      .endif
      mov    dword ptr [edi+eax],2a5ch    ;add '\*',0,0   to end of path

      @ClearFN                            ; clears the cFileName field in Win32_Find_Data
                        
      invoke FindFirstFile,addr fPath,addr WFD        ; find first file
      .if eax == -1         
        ret
      .endif

      mov    hFind,eax                    ; save FindHandle
      mov    ebx,eax                      ; put handle in EBX
                
    .while ebx > 0                        ; while a file is found..
      lea    esi,WFD.cFileName
      lodsw                               ; get first two chars

      .if AX!=02E2Eh && AX!=0002Eh        ; '..' and '.'          
        lea  edi,WFD
        mov  eax,[edi] ; file attributes

        .if ax & FILE_ATTRIBUTE_DIRECTORY       ; skip if a directory
          sub esi,2                             ; undo the lodsw
          lea edi,fPath2                        ; load up the secondary path in EDI
          xor eax,eax                           ; clear secondary path
          mov ecx,65
          rep stosd

          lea edi,fPath2
          lea eax,fPath                         ; first path
          invoke lstrcpy,edi,eax                ; copy first to second

          mov al,'*'                            ; get to the end....
          @GetToChar
          mov byte ptr [edi],0                  ; delete the wildcard
          invoke lstrcat,edi,esi                ; tack on the new directory name
          pushad                                ; must save ALL regs or errors will ocur :)
          invoke SearchForAsmFile,addr fPath2   ; call function again
          popad                                 ; restore all regs
        .else
          sub esi,2                             ; undo the lodsw
          lea edi,fPath2
          invoke lstrcpy,edi,addr fPath

          mov al,'*'
          scasb
          jnz $-1

          dec edi
          mov byte ptr [edi],0

          lea     edi,WFD.cFileName
          invoke  lstrlen,edi
          .if eax >0
            add     esi,eax
            mov     edi,esi

            sub     edi,4                         ; point to file extension
            invoke  lstrcmpi,addr AsmExt,edi      ; ASM files
            .if eax !=0                           ; not found
              mov     edi,esi
              sub     edi,3                       ; point to next file extension
              invoke  lstrcmpi,addr RcExt,edi     ; RC files
            .endif
            .if eax !=0                           ; not found
              mov     edi,esi
              sub     edi,4                       ; point to next file extension
              invoke  lstrcmpi,addr IncExt,edi    ; Inc files
            .endif

            .if eax ==0
;------------------------------------
; file found - convert the date/time
;------------------------------------
              INVOKE  FileTimeToLocalFileTime, addr WFD.ftLastWriteTime, addr Lft
              INVOKE  FileTimeToSystemTime, addr Lft, addr time

              mov    edi,offset fDate
              movzx  eax,time.wDay                          ;  create dd/mm/yyyy
              invoke wsprintf,edi,addr FmtString2,eax
              mov    byte ptr [edi+2],'/'
              add    edi,3
              movzx  eax,time.wMonth
              invoke wsprintf,edi,addr FmtString02,eax
              mov    byte ptr [edi+2],'/'
              add    edi,3
              movzx  eax,time.wYear
              invoke wsprintf,edi,addr FmtString4,eax
              mov    byte ptr [edi+4],0
              mov    edi,offset fTime
              movzx  eax,time.wHour                         ; create hh:mm:ss
              invoke wsprintf,edi,addr FmtString2,eax
              mov    byte ptr [edi+2],':'
              add    edi,3
              movzx  eax,time.wMinute
              invoke wsprintf,edi,addr FmtString02,eax
              mov    byte ptr [edi+2],':'
              add    edi,3
              movzx  eax,time.wSecond
              invoke wsprintf,edi,addr FmtString02,eax

              mov    esi,offset fDate + 6                   ; create yyyymmddhh:mm:ss
              mov    edi,offset Work16
              movsd
              mov    esi,offset fDate + 3
              movsw
              mov    esi,offset fDate 
              movsw
              mov    esi,offset fTime
              movsd
              movsd
              mov    byte ptr [edi],0
;-------------------------------------------
;  create Comma Separated Values line (CSV)
;-------------------------------------------
              invoke lstrcpy,addr TrackPath,addr Work16     ; date time
              invoke lstrcat,addr TrackPath,addr Comma
              invoke lstrcat,addr TrackPath,addr WFD.cFileName
              invoke lstrcat,addr TrackPath,addr Comma
              invoke lstrcat,addr TrackPath,addr fDate
              invoke lstrcat,addr TrackPath,addr Comma
              invoke lstrcat,addr TrackPath,addr fTime
              invoke lstrcat,addr TrackPath,addr Comma
              invoke lstrcat,addr TrackPath,addr fPath2        
              invoke lstrcat,addr TrackPath,addr WFD.cFileName
;-----------------------------------
;  clear the listbox if first entry
;-----------------------------------
              .if ClearListBox==0
                invoke SendMessage,hList,LB_RESETCONTENT,0,0
                inc    ClearListBox
              .endif
;-----------------------------------------
; add to ListBox, which will sort the
; lines into ascending order (LBS_SORT)
;-----------------------------------------
              invoke SendMessage,hList,LB_ADDSTRING,0,addr TrackPath
              inc    TotalFiles
;------------------------------
; bump the progress bar once
; for every 16 lines added
;------------------------------
              mov    eax,TotalFiles
              and    eax,0fh
              .if eax == 01
                invoke SendMessage,hwndProgress,PBM_STEPIT,0,0    ;one step
              .endif
              mov    eax,TotalFiles
              and    eax,0ffh
              .if eax == 0ffh
                invoke lstrcpy,addr TrackPath,addr fPath2        
                invoke lstrcat,addr TrackPath,addr WFD.cFileName
                invoke SetWindowText,hStatic,addr TrackPath
              .endif
            .endif
          .endif
        .endif
      .endif

      @ClearFN        ; Clear the cFileName field again
                                
      invoke FindNextFile,hFind,addr WFD
      mov    ebx,eax
    .endw

      invoke FindClose,hFind                    ; close it up

      ret

SearchForAsmFile ENDP

; ######################################################################
;------------------------------------------------------------------
;  transfer the sorted details from the listbox to a list view box
;------------------------------------------------------------------
TransferProc      proc  hWin  :DWORD

LOCAL Fcol  :DWORD
LOCAL Dcol  :DWORD
LOCAL Tcol  :DWORD
LOCAL lvc   :LV_COLUMN
LOCAL lvi   :LV_ITEM
LOCAL Row   :DWORD
LOCAL Pcol  :DWORD

      pushad                                                ;needed for win2000
;------------------------------
; create the listview control 
;      report style
;------------------------------
      .if hListV==0
        invoke CreateWindowEx, NULL, addr ListViewClassName, NULL,
                              LVS_REPORT+WS_CHILD+WS_VISIBLE+LVS_NOSORTHEADER  \
                              or WS_SYSMENU \
                              or LVS_SHOWSELALWAYS,         ; remember selection
                              0,0,0,0,hWin,                 ; with no sizes specified
                              NULL, hInstance, NULL
        mov    hListV, eax
        invoke ShowWindow, hListV,SW_SHOWNORMAL
        invoke UpdateWindow, hListV
        invoke SendMessage,hListV,LVM_SETITEMCOUNT,400,0    ; reserve some memory
        invoke SendMessage,hWnd,WM_SIZE,0,0                 ; re-size the control
;---------------------------------------------------
;  neat trick to allow double click in all columns
;---------------------------------------------------
        INVOKE     SendMessage, hListV, LVM_SETEXTENDEDLISTVIEWSTYLE,
                                0,LVS_EX_FULLROWSELECT
;---------------------------------------------------------------
;  use a font that give a neat appearance for the column lists
;---------------------------------------------------------------
        invoke GetStockObject,SYSTEM_FIXED_FONT
        invoke SendMessage,hListV,WM_SETFONT,eax,FALSE
;----------------------------------
;  sub-class to catch right click
;----------------------------------
        invoke SetWindowLong,hListV,GWL_WNDPROC,addr Ed1Proc
        mov lpfnEd1Proc, eax
;---------------------------------------
;  create 4 columns and add the titles
;---------------------------------------
        invoke    FillBuffer,addr lvc,sizeof lvc,0          ;  set all structure
                                                            ;  values to zero
        mov       lvc.imask,LVCF_TEXT+LVCF_WIDTH
        mov       lvc.pszText,offset Heading1
        m2m       lvc.lx,ColSize1
        invoke    SendMessage,hListV, LVM_INSERTCOLUMN,0,addr lvc
        or        lvc.imask,LVCF_FMT
        mov       lvc.pszText,offset Heading2
        m2m       lvc.lx,ColSize2
        invoke    SendMessage,hListV, LVM_INSERTCOLUMN, 1 ,addr lvc	
        mov       lvc.pszText,offset Heading3
        m2m       lvc.lx,ColSize3
        invoke    SendMessage,hListV, LVM_INSERTCOLUMN, 2 ,addr lvc	
        mov       lvc.pszText,offset Heading4
        m2m       lvc.lx,ColSize4
        invoke    SendMessage,hListV, LVM_INSERTCOLUMN, 3 ,addr lvc	
;-------------------------------
; if listview already exists,
; clear the contents
;-------------------------------
      .else
        invoke SendMessage,hListV,LVM_DELETEALLITEMS,0,0
      .endif
;-----------------------------------------
;  prevent screen updates whilst loading
;-----------------------------------------
      invoke SendMessage,hListV, WM_SETREDRAW, FALSE, 0
;-----------------------------------------------------
; transfer and format the data from the listbox
; to the listview window, starting at the bottom
; ie. the most recently changed.
;-----------------------------------------------------
      invoke      FillBuffer,addr lvi,sizeof lvi,0
      mov         Row,0
      invoke      SendMessage,hList,LB_GETCOUNT,0,0
      .if eax==LB_ERR
        xor       eax,eax
      .endif
      mov         ecx,eax                 ; eax = total items in listbox
      mov         esi,ItemsToShow         ; limit the items copied to Listview
      .while esi != 0  && \
             ecx != 0
        dec       ecx
        push      ecx                     ; save, will get destroyed by API's
        invoke    SendMessage,hList,LB_GETTEXT,ecx,addr TrackPath
        .if eax == LB_ERR
          pop     ecx
          .break
        .endif
        mov       ecx,eax
        mov       edi,offset TrackPath +17
        mov       al,','
        mov       Fcol,edi
        repne     scasb
        mov       byte ptr [edi-1],0
        mov       Dcol,edi
        repne     scasb
        mov       byte ptr [edi-1],0
        mov       Tcol,edi
        repne     scasb
        mov       byte ptr [edi-1],0
        mov       Pcol,edi
;-----------------------
; add items to rows
; 'insert' a row
;-----------------------
        mov      lvi.imask, LVIF_TEXT
        mov      eax,Row
        mov      lvi.iItem,eax           ;  <----- row
        mov      lvi.lParam,0
        mov      lvi.iSubItem, 0         ;  <----- column for item
        mov      eax,Fcol
        m2m      lvi.pszText,eax
        mov      lvi.iImage, 0
        INVOKE   SendMessage, hListV, LVM_INSERTITEM, 0, addr lvi ; <-- 'insert'
;---------------------------------
; add items to rows
; 'set' another item to the row
;---------------------------------
        m2m      lvi.iItem,Row           ;  <----- row
        mov      lvi.lParam,0
        mov      lvi.iSubItem, 1         ;  <----- column for item
        m2m      lvi.pszText,Dcol
        mov      lvi.iImage, 0
        INVOKE   SendMessage, hListV, LVM_SETITEM, 0, addr lvi    ; <-- 'set'

        m2m      lvi.iItem,Row           ;  <----- row
        mov      lvi.lParam,0
        mov      lvi.iSubItem, 2         ;  <----- column for item
        m2m      lvi.pszText,Tcol
        mov      lvi.iImage, 0
        INVOKE   SendMessage, hListV, LVM_SETITEM, 0, addr lvi    ; <-- 'set'

        m2m      lvi.iItem,Row           ;  <----- row
        mov      lvi.lParam,0
        mov      lvi.iSubItem, 3         ;  <----- column for item
        m2m      lvi.pszText,Pcol
        mov      lvi.iImage, 0

        INVOKE   SendMessage, hListV, LVM_SETITEM, 0, addr lvi    ; <-- 'set'

        inc      Row
        pop      ecx
        dec      esi
      .endw        
;-------------------------------------------
;  allow screen updates and force a redraw
;-------------------------------------------
      invoke SendMessage,hListV, WM_SETREDRAW, TRUE, 0
      invoke UpdateWindow,hListV

      popad                                           ; for win2000

      ret

TransferProc      endp
; #######################################################################

GetFileName proc hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD

      mov ofn.lStructSize,        sizeof OPENFILENAME
      m2m ofn.hWndOwner,          hParent
      m2m ofn.hInstance,          hInstance
      m2m ofn.lpstrFilter,        lpFilter
      m2m ofn.lpstrFile,          offset szFileName
      mov ofn.nMaxFile,           sizeof szFileName
      m2m ofn.lpstrTitle,         lpTitle
      mov ofn.Flags,              OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                                  OFN_LONGNAMES

      invoke GetOpenFileName,ADDR ofn

      ret

GetFileName endp

; #########################################################################

FillBuffer proc uses esi edi eax ecx,
                lpBuffer:DWORD,
                lnBuffer:DWORD,
                TheChar :BYTE

      mov   edi, lpBuffer     ; address of buffer
      mov   ecx, lnBuffer     ; buffer length
      mov    al, TheChar      ; load al with character
      rep    stosb            ; write character to buffer until ecx = 0

    ret

FillBuffer endp

; #########################################################################

PushButton proc lpText:DWORD,hParent:DWORD,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

    szText btnClass,"BUTTON"

    invoke CreateWindowEx,0,
            ADDR btnClass,lpText,
            WS_CHILD or WS_VISIBLE,
            a,b,wd,ht,hParent,ID,
            hInstance,NULL
    ret

PushButton endp

; ########################################################################

BrowseForFolder proc hParent:DWORD, lpBuffer:DWORD, lpTitle:DWORD, lpString:DWORD

; ------------------------------------------------------
; hParent  = parent window handle
; lpBuffer = 260 byte buffer to receive path
; lpTitle  = zero terminated string with dialog title
; lpString = zero terminated string for secondary text
; ------------------------------------------------------

      LOCAL lpIDList :DWORD
      LOCAL bi       :BROWSEINFO

      mov   eax,                hParent         ; parent handle
      mov   bi.hwndOwner,       eax
      mov   bi.pidlRoot,        0
      mov   bi.pszDisplayName,  0
      mov   eax,                lpString        ; secondary text
      mov   bi.lpszTitle,       eax
      mov   bi.ulFlags,         BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN
      mov   bi.lpfn,            offset cbBrowse
      mov   eax,                lpTitle         ; main title
      mov   bi.lParam,          eax
      mov   bi.iImage,          0

      invoke SHBrowseForFolder,ADDR bi
      mov lpIDList, eax

      .if lpIDList == 0
        mov    eax, 0      ; if CANCEL return FALSE
        push   eax
        jmp    @F
      .else
        invoke SHGetPathFromIDList,lpIDList,lpBuffer
        mov    eax, 1        ; if OK, return TRUE
        push   eax
        jmp    @F
      .endif
@@:
      invoke CoTaskMemFree,lpIDList

      pop   eax
      ret

BrowseForFolder endp

; #########################################################################

cbBrowse proc hWin   :DWORD,
              uMsg   :DWORD,
              lParam :DWORD,
              lpData :DWORD

    invoke SetWindowText,hWin,lpData

    ret

cbBrowse endp

; #########################################################################
SearchNewFolder   proc  hWin :DWORD

LOCAL lpBuffer [260]    :BYTE

;-------------------------------
; cancel current search thread
; before running it again
;-------------------------------
      .if ThreadHandle>0
        invoke CloseHandle,ThreadHandle
        mov   ThreadHandle,0
      .endif
;----------------------------------
; show folder selection window
;----------------------------------
      lea    edi,lpBuffer
      mov    byte ptr [edi],0
      push   edi
      invoke BrowseForFolder,hWin,addr lpBuffer,addr SearchMsg,0
      pop    edi
      .if byte ptr [edi] != 0         ; folder selected
        mov    TotalFiles,0
        invoke lstrcpy,addr ModulePath,addr lpBuffer
;----------------------------------
; create 'search for files' thread
;----------------------------------
        invoke CreateThread,NULL,NULL,addr FindFiles,hWin,0,ADDR ThreadID 
        mov    ThreadHandle,eax        
      .else                                     ; no folder chosen, return to listview
        invoke SetFocus,hListV                  ; highlight the selected items
      .endif
      ret

SearchNewFolder   endp
;##########################################################################

Copy2ClipBoard    proc

LOCAL lvi   :LV_ITEM
LOCAL dMem  :DWORD
LOCAL hMem  :DWORD

LOCAL Items2Copy  :DWORD
LOCAL ItemIndex   :DWORD
LOCAL SubItem     :DWORD

LOCAL szBuff   [260]    :BYTE

;--------------------------------------------------
;  get number of items to copy from listview
; and calculate the max memory allocation needed
;--------------------------------------------------
      invoke SendMessage,hListV,LVM_GETSELECTEDCOUNT,0,0
      mov    Items2Copy,eax
      shl    eax,9                  ; X 512 max size of items
;-------------------------------------------
;  allocate some memory for the items data
;  and get the memory address
;-------------------------------------------
      invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,eax
      mov    hMem,eax
      .if eax==0
        ret
      .endif
      invoke GlobalLock,eax         ; lock the object to get the addr
      mov    dMem,eax
      mov    byte ptr [eax],0       ; asciiz
;----------------------------------------------------
;  retrieve the items data from the listview window
;----------------------------------------------------
      invoke  FillBuffer,addr lvi,sizeof lvi,0
      mov    ItemIndex,-1
      .while Items2Copy !=0
        invoke SendMessage,hListV,LVM_GETNEXTITEM,ItemIndex,LVNI_SELECTED	
        .if eax == -1
          .break
        .endif
        mov ItemIndex,eax

        mov     SubItem,0
        .while SubItem !=4                      ; listview has 4 columns
          mov     eax,ItemIndex
          mov     lvi.iItem, eax
          mov     eax,SubItem
          mov     lvi.iSubItem,eax
          mov     lvi.imask, LVIF_TEXT
          lea     eax, szBuff
          mov     lvi.pszText, eax
          mov     lvi.cchTextMax, 256
          invoke  SendMessage, hListV, LVM_GETITEM, 0, addr lvi
          .if eax == FALSE
            .break
          .endif

          invoke lstrcat,dMem,addr szBuff
          invoke lstrcat,dMem,addr Comma
          inc    SubItem
        .endw
        invoke lstrcat,dMem,addr CRLF
        dec Items2Copy
      .endw
;------------------------------------
;  move the data to the clipboard
;------------------------------------
      invoke OpenClipboard,NULL
      .if eax==0
        jmp @F
      .endif

      invoke EmptyClipboard
      .if eax==0
        jmp @F
      .endif

      invoke SetClipboardData,CF_OEMTEXT,dMem
@@:
      invoke CloseClipboard

      .if hMem>0
        invoke GlobalUnlock,hMem
        invoke GlobalFree,hMem
      .endif

      ret

Copy2ClipBoard    endp
; ####################################################################

Ed1Proc proc hCtl   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

LOCAL pt    :POINT

;-------------------------------------------
; Process mouse right click messages here
; Create/show pop-up menu for buttun up
;-------------------------------------------
      .if uMsg==WM_RBUTTONUP 
        .if hMenuP==0
          call    BuildPopUpMenu          ; create our popup menu
        .endif
;-------------------------------
; enable/disable popup commands
;-------------------------------
        invoke SendMessage,hList,LB_GETCOUNT,0,0  ; get file count
        .if eax==0                                ; no files = nothing to select
          invoke EnableMenuItem,hMenuP,IDM_SELECT,MF_DISABLED or MF_GRAYED
        .else
          invoke EnableMenuItem,hMenuP,IDM_SELECT,MF_ENABLED
        .endif

        invoke SendMessage,hListV,LVM_GETSELECTEDCOUNT,0,0
        push   eax
        .if eax==0            ; disable clipboard function if no files are selected
          invoke EnableMenuItem,hMenuP,IDM_COPY,MF_DISABLED or MF_GRAYED   
        .else
          invoke EnableMenuItem,hMenuP,IDM_COPY,MF_ENABLED
        .endif
        pop    eax
        .if eax==1
          invoke EnableMenuItem,hMenuP,IDM_VIEW,MF_ENABLED
        .else
          invoke EnableMenuItem,hMenuP,IDM_VIEW,MF_DISABLED or MF_GRAYED
        .endif

        invoke DrawMenuBar,hMenuP
;-----------------------------------------------------
; calculate the display position for the popup menu
;-----------------------------------------------------
        mov eax, lParam             ; listview co-ordinates
        and eax, 0ffffh             ; need to be converted
        mov ebx, lParam             ; to the screen co-ordinates
        shr ebx, 16
        mov pt.x,eax
        mov pt.y,ebx
        invoke ClientToScreen,hListV,addr pt
        invoke TrackPopupMenu,hMenuP,TPM_LEFTALIGN,pt.x,pt.y,0,hWnd,0
        return 0
;----------------------------
; Skip button down messages
;----------------------------
      .elseif uMsg==WM_RBUTTONDOWN
        return 0
;-------------------------------------------
; re-direct keyboard chars to parent window
;-------------------------------------------
      .elseif uMsg==WM_CHAR
        invoke SendMessage,hWnd,uMsg,wParam,lParam
        return 0
      .endif

      invoke CallWindowProc,lpfnEd1Proc,hCtl,uMsg,wParam,lParam

      ret

Ed1Proc endp

; #########################################################################

BuildPopUpMenu    proc

LOCAL mii   :MENUITEMINFO
;----------------------------------------------------------------
;  this routine will create our popup menu, it is only run once.
;----------------------------------------------------------------
      .if hMenuP==0
        invoke CreatePopupMenu    ; Create a PopupMenu structure
        mov    hMenuP, eax        ; and save it's handle
;------------------------
;  set up mii structure
;------------------------
        invoke FillBuffer,addr mii,sizeof mii,0
        mov    mii.cbSize, sizeof mii
        mov    mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE \
                          or MIIM_TYPE
;----------------------------------
; add commands one line at a time
;----------------------------------
        .if ViewerPath(0) !=0
          invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                            IDM_VIEW,NULL
          mov    mii.wID, IDM_VIEW
          mov    mii.dwTypeData,offset ViewMsg
          invoke SetMenuItemInfo,hMenuP,IDM_VIEW,FALSE,addr mii   ; file view
        .endif

        invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                          IDM_OPEN,NULL
        mov    mii.wID, IDM_OPEN
        mov    mii.dwTypeData,offset FileMsg
        invoke SetMenuItemInfo,hMenuP,IDM_OPEN,FALSE,addr mii     ; choose file

        invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                          IDM_FOLDER,NULL
        mov    mii.wID, IDM_FOLDER
        mov    mii.dwTypeData,offset FolderMsg
        invoke SetMenuItemInfo,hMenuP,IDM_FOLDER,FALSE,addr mii   ; new folder

        invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                          IDM_COPY,NULL
        mov    mii.wID, IDM_COPY
        mov    mii.dwTypeData,offset CopyMsg
        invoke SetMenuItemInfo,hMenuP,IDM_COPY,FALSE,addr mii     ; copy to clipboard

        invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                          IDM_SELECT,NULL
        mov    mii.wID, IDM_SELECT
        mov    mii.dwTypeData,offset SelectMsg
        invoke SetMenuItemInfo,hMenuP,IDM_SELECT,FALSE,addr mii   ; select all

        invoke AppendMenu,hMenuP,MF_STRING or MF_ENABLED,\
                          IDM_SHOWALL,NULL
        mov    mii.wID, IDM_SHOWALL
        mov    mii.dwTypeData,offset ChangeMsg
        invoke SetMenuItemInfo,hMenuP,IDM_SHOWALL,FALSE,addr mii   ; show all

      .endif

      ret

BuildPopUpMenu    endp
; #####################################################################

ShowHelpWindow    proc  hWin :DWORD

LOCAL EntrySize   :DWORD
;------------------------------------------------------------
;  first time through create an empty listbox with no sizes
;------------------------------------------------------------
      .if hListH==0
        invoke ListBox,0,0,0,0,hWin,602
        .if eax == 0
          invoke  MessageBoxEx,hWin,addr NoHelpMsg,addr szDisplayName,\
                               MB_ICONQUESTION or MB_OK, NULL	
          ret
        .endif
        mov    hListH,eax
;-----------------------------------------------------------------
;  sub class the window so we can catch keyboard and mouse action
;-----------------------------------------------------------------
        invoke SetWindowLong,hListH,GWL_WNDPROC,ListBoxProc
        mov    ListBoxReturnAddr, eax
;---------------------------------------
;  load listbox with the help text
;---------------------------------------
        mov    esi,offset HelpMsg
        mov    eax,esi
        mov    EntrySize,0
        .while eax !=0                                      ; stop after a blank line
          invoke SendMessage,hListH,LB_ADDSTRING,0,esi
          .if eax==LB_ERR
            .break
          .endif
          invoke lstrlen,esi
          add    esi,eax
          inc    esi
          .if eax>EntrySize           ; find the max size of the help lines
            mov  EntrySize,eax
          .endif
        .endw
;-------------------------------------
;  create a horizontal position bar
;-------------------------------------
        mov   eax,EntrySize           ; need to change chars to pixels
        shl   eax,3                   ; assume 8 pixels per char
        invoke SendMessage,hListH,LB_SETHORIZONTALEXTENT,eax,0
      .endif
;--------------------------------------------------------
; now show the help listbox and disable everything else
;--------------------------------------------------------
      invoke ShowWindow,hListV,SW_HIDE          ; hide the listview
      invoke ShowWindow,hListH,SW_SHOW          ; show the help listbox
      invoke SendMessage,hWin,WM_SIZE,0,0       ; adjust the size

      invoke EnableWindow,hButn,FALSE           ; disable new project button

      invoke EnableMenuItem,hMenu,IDM_FILE,MF_DISABLED or MF_GRAYED
      invoke EnableMenuItem,hMenu,IDM_HELPM,MF_DISABLED or MF_GRAYED
      invoke DrawMenuBar,hWnd
      
      return 0

ShowHelpWindow    endp
; #################################################################
.data
RootDir     db    'C:\',0
MasmDir     db    'masm32',0
.code

FindQ proc
LOCAL SaveEDX     :DWORD
;----------------------------------------------------
;  find Qeditor the hard way, search all hard drives
;  for a masm32 folder in its root directory.
;----------------------------------------------------
      mov    dl,'C'
      .while dl !='Z'
        mov    edi,offset RootDir
        mov    [edi],dl
        mov    SaveEDX,edx
        invoke GetDriveType,addr RootDir
        .if eax<2                   ; unknown or invalid drive type
          .break
        .endif
        .if eax==3                  ; hard drive
          invoke lstrcpy,addr ModulePath,addr RootDir
          invoke lstrcat,addr ModulePath,addr MasmDir
          invoke SearchForFile,addr ModulePath,addr EditorName, addr EditorPath
          .if eax !=-1
            return 0                ; found, set return value
          .endif
        .endif

        mov edx,SaveEDX
        inc edx                     ; next drive letter
      .endw

      return -1                     ; not found, set return value

FindQ endp
; ##########################################################################
end   start

LVS_EX_ALTERNATEROWCOLOR 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Alternates the background color of the rows.
(To produce an effect similar to continuous computer paper
called 'shadow', first produced for mainframes.)

LVS_EX_AUTOAUTOARRANGE 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Icons automatically arrange if no icon positions have been set
 (Similar to LVS_AUTOARRANGE).
(Beta testers have given this an Annoyance Factor of 4, slightly less than
that given to Supermarkets that completely re-arrange their shelves
overnight.)

LVS_EX_AUTOCHECKSELECT 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Automatically select check boxes on single click.

LVS_EX_AUTOSIZECOLUMNS 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Automatically size listview columns.

LVS_EX_BORDERSELECT 
Version 4.71. If this style is set, when an item is selected the border color
of the item changes rather than the item being highlighted.

LVS_EX_CHECKBOXES 
Version 4.70. Enables check boxes for items in a list-view control. When set
to this style, the control creates and sets a state image list with two images
using DrawFrameControl. State image 1 is the unchecked box, and state image 2
is the checked box. Setting the state image to zero removes the check box altogether.

Version 6.00 Check boxes are visible and functional with all list-view modes except
the tile view mode introduced in ComCtl32.dll version 6. Clicking a checkbox in tile
view mode only selects the item; the state does not change.

You can obtain the state of the check box for a given item with ListView_GetCheckState.
To set the check state, use ListView_SetCheckState. If this style is set, the list-view
control automatically toggles the check state when the user clicks the check box or
presses the space bar.


LVS_EX_COLUMNOVERFLOW 

LVS_EX_COLUMNSNAPPOINTS 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Snap to minimum column width when the user resizes a column.

LVS_EX_DOUBLEBUFFER 
Version 6.00. Paints via double-buffering, which reduces flicker. This extended
style also enables alpha-blended marquee selection on systems where it is supported.

LVS_EX_FLATSB 
Version 4.71. Enables flat scroll bars in the list view. If you need more
control over the appearance of the list-view's scroll bars, you should
manipulate the list-view's scroll bars directly using the Flat Scroll
Bar APIs. If the system metrics change, you are responsible for adjusting
the scroll bar metrics with FlatSB_SetScrollProp.
 See Flat Scroll Bars for further details.

LVS_EX_FULLROWSELECT 
Version 4.70. When an item is selected, the item and all its subitems are
highlighted. This style is available only in conjunction with the LVS_REPORT style.

LVS_EX_GRIDLINES 
Version 4.70. Displays gridlines around items and subitems. This style
is available only in conjunction with the LVS_REPORT style.

LVS_EX_HEADERDRAGDROP 
Version 4.70. Enables drag-and-drop reordering of columns in a list-view
control. This style is only available to list-view controls
that use the LVS_REPORT style.

LVS_EX_HEADERINALLVIEWS 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Show column headers in all view modes.

LVS_EX_INFOTIP 
Version 4.71. When a list-view control uses the LVS_EX_INFOTIP style,
the LVN_GETINFOTIP notification message is sent to the parent window
before displaying an item's ToolTip.

LVS_EX_JUSTIFYCOLUMNS 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Icons are lined up in columns that use up the whole view.

LVS_EX_LABELTIP 
Version 5.80. If a partially hidden label in any list-view mode lacks
ToolTip text, the list-view control will unfold the label. If this style
is not set, the list-view control will unfold partly hidden labels
only for the large icon mode.

LVS_EX_MULTIWORKAREAS 
Version 4.71. If the list-view control has the LVS_AUTOARRANGE style,
the control will not autoarrange its icons until one or more work areas
are defined (see LVM_SETWORKAREAS). To be effective, this style must
be set before any work areas are defined and any items have been added
to the control.

LVS_EX_ONECLICKACTIVATE 
Version 4.70. The list-view control sends an LVN_ITEMACTIVATE notification
message to the parent window when the user clicks an item. This style also
enables hot tracking in the list-view control. Hot tracking means that when 
the cursor moves over an item, it is highlighted but not selected.
See the Extended List-View Styles Remarks section for a discussion of item
activation.

LVS_EX_REGIONAL 
Version 4.71. Sets the list-view window region to include only the item icons
and text using SetWindowRgn. Any area that is not part of an item is excluded
from the window region. This style is only available to list-view controls
that use the LVS_ICON style.

LVS_EX_SIMPLESELECT 
Version 6.00. In icon view, moves the state image of the control to the top right
of the large icon rendering. In views other than icon view there is no change.
When the user changes the state by using the space bar, all selected items
cycle over, not the item with the focus.

LVS_EX_SUBITEMIMAGES 
Version 4.70. Allows images to be displayed for subitems. This style is 
available only in conjunction with the LVS_REPORT style.

LVS_EX_TRACKSELECT 
Version 4.70. Enables hot-track selection in a list-view control. Hot track
selection means that an item is automatically selected when the cursor
remains over the item for a certain period of time. The delay can be changed
from the default system setting with a LVM_SETHOVERTIME message. This style 
applies to all styles of list-view control. You can check whether hot-track 
selection is enabled by calling SystemParametersInfo.

LVS_EX_TRANSPARENTBKGND 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Background is painted by the parent via WM_PRINTCLIENT.

LVS_EX_TRANSPARENTSHADOWTEXT 
Note  This documentation is preliminary and is subject to change.
Windows Vista. Enable shadow text on transparent backgrounds only.

LVS_EX_TWOCLICKACTIVATE 
Version 4.70. The list-view control sends an LVN_ITEMACTIVATE notification 
message to the parent window when the user double-clicks an item. 
This style also enables hot tracking in the list-view control. 
Hot tracking means that when the cursor moves over an item, it is highlighted
but not selected. See the Extended List-View Styles Remarks section for a
discussion of item activation.

LVS_EX_UNDERLINECOLD 
Version 4.71. Causes those non-hot items that may be activated to be displayed
with underlined text. This style requires that LVS_EX_TWOCLICKACTIVATE be set
also. See the Extended List-View Styles Remarks section for a discussion 
of item activation.

LVS_EX_UNDERLINEHOT 
Version 4.71. Causes those hot items that may be activated to be displayed 
with underlined text. This style requires that LVS_EX_ONECLICKACTIVATE or 
LVS_EX_TWOCLICKACTIVATE also be set. See the Extended List-View Styles 
Remarks section for a discussion of item activation.

Remarks

Note  Comctl32.dll version 6 is not redistributable but it is included in 
Microsoft Windows XP or later. To use Comctl32.dll version 6, specify it
in a manifest. For more information on manifests, see Using Windows XP
Visual Styles.
An item becomes hot when the mouse hovers over it. If hot-tracking is
enabled, hot items will be highlighted, but the user must still click 
the item at least once to select it. Activating an item causes the 
list-view control to send an LVN_ITEMACTIVATE notification. An item 
may be selected when it is in a state in which a single click will 
select it.

If the LVS_EX_ONECLICKACTIVATE style is set, only one click is required 
to select any item, so all items may be selected. If the 
LVS_EX_TWOCLICKACTIVATE style is set, two clicks are required to select 
an item. With this style, the item may be selected only after it has 
been clicked once.

Setting the LVS_EX_UNDERLINEHOT style will cause the text of any hot item 
that may be selected to be underlined. Setting the LVS_EX_UNDERLINECOLD 
style will cause the text of items that are not hot, but may be selected, 
to be underlined.


ONLY AVAILABLE IN Vista for Dorks.
LVS_DYNABOLT
Sending a LVS_DYNABOLT message will lock an item to a specified location
in the listview control. The lock can only be removed by sending a
LVS_JACKHAMMER message.   When used on the desktop icons the appearance 
of the desktop will not change even after a system crash.  This style
supercedes the LVS_SETINCONCRETE command.

LVS_RIGHTCLICKNOCANCEL
If the  LVS_RIGHTCLICKNOCANCEL style is set, items in a listview control
may only be selected by using the left mouse button. The right mouse button
will no longer de-select those items already selected.  
 